
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "base/polygraph.h"

#include "xstd/String.h"
#include "client/cltReqTypes.h"


class CltReqTypesArr: public Array<String*> {
	public:
		CltReqTypesArr();
		~CltReqTypesArr();

	protected:
		String &str(int idx);
};

CltReqTypesArr TheCltReqTypeIdx;


CltReqTypesArr::CltReqTypesArr(): Array<String*>(rtpEnd) {

	str(rtpBasic)  = "Basic";
	str(rtpIMS)    = "IMS";
	str(rtpReload) = "Reload";

	// check that all are defined
	for (int i = 0; i < rtpEnd; ++i)
		Assert(item(i) && *item(i));
}

CltReqTypesArr::~CltReqTypesArr() {
	while (count()) delete pop();
}

String &CltReqTypesArr::str(int idx) {
	Assert(0 <= idx && idx < rtpEnd);
	Assert(count() <= idx || !item(idx));
	put(new String, idx);
	return *item(idx);
}



const Array<String*> &CltReqTypeIdx() {
	return TheCltReqTypeIdx;
}
