
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "pgl.h"

#include "String.h"
#include "PglRec.h"
#include "LogSym.h"


LogSym::LogSym(): RecSym("Log", new PglRec) {

	// add fields

	theRec->bAdd("string", "fname", 0);
	theRec->bAdd("size",  "size", 0);
}

LogSym::LogSym(const String &aType, PglRec *aRec): RecSym(aType, aRec) {
	// find fields
}

bool LogSym::isA(const String &type) const {
	return RecSym::isA(type) ||	type == "Log";
}

SynSym *LogSym::clone(const String &type) const {
	if (isA(type))
		return new LogSym(this->type(), theRec->clone());
	return RecSym::clone(type);
}
