
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_EXPRESSION_SYMBOL_H
#define PGL_EXPRESSION_SYMBOL_H

#include "SynSym.h"

// base class for all kind of "expressions"
class ExpressionSym: public SynSym {
	public:
		ExpressionSym(const char *aType): SynSym(aType) {}

		// clone self and apply a given operator (unary or binary);
		// by default, complains about unsupported operation
		virtual ExpressionSym *unOper(const String &op) const;
		virtual ExpressionSym *bnOper(const String &op, const SynSym &exp) const;

		virtual bool isA(const String &type) const;

	protected:
		void checkDenom(int val) const;
		void checkDenom(double val) const;
};

#endif
