
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_NETWORK_ADDRESS_SYMBOL_H
#define PGL_NETWORK_ADDRESS_SYMBOL_H

#include "PglRecSym.h"
#include "NetAddr.h"

class SynSymTblItem;
class StringSym;
class String;

// host:port network address

class NetAddrSym: public RecSym {
	public:
		NetAddrSym();
		NetAddrSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		virtual ExpressionSym *bnOper(const String &op, const SynSym &s) const;

		NetAddr val() const;
		void val(const NetAddr &addr);

		virtual ostream &print(ostream &os, const String &pfx) const;
};

#endif
