
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "pgl.h"

#include "PglRec.h"
#include "StatsSampleSym.h"


StatsSampleSym::StatsSampleSym(): RecSym("StatsSample", new PglRec) {
	theRec->bAdd("string", "name", 0);
	theRec->bAdd("time", "start", 0);
	theRec->bAdd("int", "capacity", 0);
}

StatsSampleSym::StatsSampleSym(const String &aType, PglRec *aRec): RecSym(aType, aRec) {
}

bool StatsSampleSym::isA(const String &type) const {
	return RecSym::isA(type) || type == "StatsSample";
}

SynSym *StatsSampleSym::clone(const String &type) const {
	if (isA(type))
		return new StatsSampleSym(this->type(), theRec->clone());
	return RecSym::clone(type);
}

String StatsSampleSym::name() const {
	return getString("name");
}

Time StatsSampleSym::start() const {
	return getTime("start");
}

bool StatsSampleSym::capacity(int &cap) const {
	return getInt("capacity", cap);
}
