
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "pgl.h"

#include "UniqIdSym.h"


// XXX: borrowing UniId type from "../" results in pgl_test not being able to
// compile due to *Log type definitions missing


UniqIdSym::UniqIdSym(const UniqId &aVal): ExpressionSym("uniq_id"), theVal(aVal) {
}

bool UniqIdSym::isA(const String &type) const {
	return ExpressionSym::isA(type) ||
		type == "UniqId" || type == "uniq_id";
}

SynSym *UniqIdSym::clone(const String &type) const {
	if (isA(type))
		return new UniqIdSym(theVal);
	return ExpressionSym::clone(type);
}

ostream &UniqIdSym::print(ostream &os, const String &) const {
	return os << theVal;
}
