
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_EXPLICIT_PORT_MGR_H
#define PG_EXPLICIT_PORT_MGR_H

#include "Ring.h"
#include "runtime/PortMgr.h"

// fifo pool of ports, explicit mapping with bind
class ExpPortMgr: public PortMgr {
	public:
		ExpPortMgr(const NetAddr &anAddr, int aPortMin, int aPortMax);

		void configure(int aPortMin, int aPortMax);

	protected:

		virtual int allocPort(Socket &s);
		virtual void freePort(int port, bool good);

		int findPort(Ring<int> &ports, Socket &s);
		bool bindToPort(Socket &s, int port) const;
		bool usedPort(int port) const;

	protected:
};

#endif
