
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef LOG_COMMENT_H
#define LOG_COMMENT_H

#include <strstream.h>

#include "base/OLog.h"

/* useful to write comments (free style messages) to a log file
 *  usage:
 *          Comment(level) << ... << endc;
 */

class LogComment: public ostrstream {
	public:
		LogComment();

		LogComment &operator ()(int aLevel) { TheCurLevel = aLevel; return *this; }

		void reset() { seekp(0); TheCurLevel = 0; }

	public:
		static int TheEchoLevel;
		static int TheCurLevel;

	protected:
		static char TheBuf[8*1024];
};

extern LogComment Comment;
extern ostream &endc(ostream &os);

#endif
