
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_XACTION_FARM_H
#define PG_XACTION_FARM_H

#include "Farm.h"

// we need a farm that can supply *Xact without owner knowing the "*" part,
// where *Xact is assumed to be Clt/SrvXact or derived from them

// interface for users
template <class Side>
class XactFarm {
	public:
		virtual ~XactFarm() {}
		virtual void limit(int limit) = 0;
		virtual Side *get() = 0;
		virtual void put(Side *x) = 0;
};

// use this template to build real farms
template <class Side, class Xact>
class XactFarmT: public XactFarm<Side> {       
	public:
		XactFarmT() { theFarm = new ObjFarm<Xact>; }
		virtual ~XactFarmT() { delete theFarm; } 

		virtual void limit(int l) { theFarm->limit(l); } 
		virtual Side *get() { return theFarm->get(); } 
		virtual void put(Side *x) { theFarm->put((Xact*)x); } 

	protected:                                                
		ObjFarm<Xact> *theFarm; 
};

#endif
