
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_CLIENT_GROUP_MAP_H
#define PG_CLIENT_GROUP_MAP_H

#include "Array.h"

class UniqId;
class CltGroupRep;

// a GroupId <-> CltGroupRep map
// add-only operation
// per Server agent information
class CltGroupMap {
	public:
		CltGroupMap();
		~CltGroupMap();

		int capacity() const { return theIndex.capacity(); }
		int count() const { return theCount; }

		CltGroupRep *at(int idx); // idx may be out of bounds
		CltGroupRep *at(const UniqId &group);
		// will create if needed
		CltGroupRep *get(const UniqId &group);

	protected:
		bool find(const UniqId &group, int &idx) const;
		CltGroupRep *addAt(int idx, const UniqId &group);
		bool endSearch(const UniqId &group, int idx, bool &res) const;

	protected:
		Array<CltGroupRep*> theIndex;
		int theCount;       // entries in the index
};

#endif
