
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_CLIENT_GROUP_REPRESENTATIVE_H
#define PG_CLIENT_GROUP_REPRESENTATIVE_H

// server side "representative" of polyclt (not individual Clients)
// holds server agent knowledge about the Client group

#include "base/UniqId.h"

class ReqHdr;
class SrvHistory;

class CltGroupRep {
	public:
		CltGroupRep(const UniqId &anId, int aGroupIdx);

		const UniqId &id() const { return theId; }
		int groupIdx() const { return theGroupIdx; }

		int nidPack() const { return theNidPack; }
		int nidStart() const { return theNidStart; }
		int nidCount() const { return theNidCount; }

		int lastReqPos() const { return theReqPos; }
		void syncGroupInfo(const ReqHdr &req, SrvHistory &hist);

	protected:
		UniqId theId;
		int theGroupIdx;    // index into the group map
		int theReqPos;      // to ignore too old requests
		int theRepPos;      // to ignore too young requests

		int theNidPack;     // pending new oids pack information
		int theNidStart;
		int theNidCount;
};

#endif
