
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "polygraph.h"

#include <limits.h>
#include <stdlib.h>

#include "Rnd.h"
#include "base/RndPermut.h"
#include "gadgets.h"


static
int uncorr(int n) {
	//int exp;
	//const double x = INT_MAX * (2*frexp(::sin((double)n), &exp) - 1);
	const double x = INT_MAX * ::sin(n*(double)n);
	return (int)Min(fabs(x), (double)INT_MAX);
}

int main(int argc, char *argv[]) {
	int sampleCount = -1;
	if (argc != 2 || !isInt(argv[1], sampleCount)) {
		cerr << "usage: " << argv[0] << " <number_of_samples>" << endl;
		return 0;
	}

	RndGen rngCont;
	RndGen rngSeeded;
	RndGen rngPermut;

	for (int i = 1; i <= sampleCount; ++i) {
		rngSeeded.seed(i);
		rngPermut.seed(RndPermut(i));
		cout << random()
			<< ' ' << rngCont.ltrial()
			<< ' ' << rngSeeded.ltrial()
			<< ' ' << rngPermut.ltrial()
			<< ' ' << uncorr(i)
			<< endl;
	}

}
